interface IImage {
  pixels: Uint8Array
  nrows: number
  ncols: number
  ldim: number
}

interface ICascadeParams {
  scalefactor: number
  shiftfactor: number
  minsize: number
  maxsize: number
}

type ClassifyRegionFunction = (r: any, c: any, s: any, pixels: any, ldim: any) => number

declare module 'picojs' {
  function instantiate_detection_memory(value: number)

  function unpack_cascade(bytes: Int8Array)

  function run_cascade(image: IImage, facefinderClassifyRegion: ClassifyRegionFunction, params: ICascadeParams)

  function cluster_detections(dets: any, value: number)
}
